<?php

/*
CMSimple_XH admin plugin
copyright 2010 - Leen Moerland(cmsimple.mldwebsites.nl)
This work is licensed under GNU General Public License Version 3
---------------------------------------------------------------------
Version:      MLDadmin_XH 2
---------------------------------------------------------------------
Build:        1612201001
---------------------------------------------------------------------
Release date: 16-12-2010
---------------------------------------------------------------------
Manual:       http://cmsimple.mldwebsites.nl/?Plugins:MLDadmin_XH
---------------------------------------------------------------------
Disclaimer:   No warranties at all, use on your own risk !
---------------------------------------------------------------------
Requirements: CMSimple_XH 1.0 or higher is installed and running.
Tested with:  Mozilla Forefox 3.5 Safari 4.0, Internet Explorer 8
---------------------------------------------------------------------
Feedback to:  leen [at] mldwebsites [dot] nl
---------------------------------------------------------------------

Changelog:
---------------------------------------------------------------------
////Version 2.0\\\\
- Removed extra editor functionality (Impossible to make this work as plugin)
- added enable/disable this plugin setting
- Improved template compatibility
- Improved images and download manager
- No template switch after saving the site settings


////Version 1.2\\\\
- changed template extension to .htm
- line 100, index.php
    :> $pth['file']['template']=$pth['folder']['template'].'template.html';
    => $pth['file']['template']=$pth['folder']['template'].'template.htm';
- minor layout fixes
- hide userfile if requested from browser

////Version 1.1\\\\
- added extra editor functionality (experimental)
*/

//start session if isn't started already
if(!isset($_SESSION)) { session_start(); }

initvar('MLDimages');
initvar('MLDdownloads');

//Check if plugin is enabled
if((isset($plugin_cf['MLDadmin']['enabled']) && $plugin_cf['MLDadmin']['enabled'] == 'true') && $adm) {
	
    if((isset($_SESSION['mldadmin_preview']) && $_SESSION['mldadmin_preview'] == 'preview') && !$edit) {
        $mldpreview = true;
		$edit = false;
    } elseif(isset($preview)) {
        $mldpreview = true;
		$edit = false;
        $_SESSION['mldadmin_preview'] = 'preview';
    } elseif(isset($_SESSION['mldadmin_preview']) && $_SESSION['mldadmin_preview'] == 'edit') {
        $mldpreview = false;
    } elseif($edit) {
        $mldpreview = false;
        $_SESSION['mldadmin_preview'] = 'edit';
    }

    //backlink if previewing
    if($adm && $mldpreview) {
        $html = '<div id="MLDadmin_backlink">'.a($s, amp().'edit').$plugin_tx['MLDadmin']['backtoadmin'].'</a></div>';
        echo $html;
    }
	
    //admintemplate if logged in, but not previewing
    if(!$mldpreview) {
        $admintemplate = $plugin_cf['MLDadmin']['template'];
        $pth['folder']['template']=$pth['folder']['templates'].$admintemplate.'/';
        $pth['file']['stylesheet']=$pth['folder']['template'].'stylesheet.css';
        $pth['folder']['menubuttons']=$pth['folder']['template'].'menu/';
        $pth['folder']['templateimages']=$pth['folder']['template'].'images/';
        $pth['file']['template']=$pth['folder']['template'].'template.htm';
    }

    //hide old pluginmenu    
    if($plugin_cf['MLDadmin']['new_plugin_menu'] == "true" && !$mldpreview) {        
        $regexp = '/<table class="edit" style="width: 100%;" cellpadding="1" cellspacing="0">\s<tr>/i';
        $replace = '<table class="edit" style="width: 100%;" cellpadding="1" cellspacing="0"><tr style="display: none;">';
        $o = preg_replace($regexp, $replace, $o);
		
		$regexp = '/<table class="edit" style="width: 100%;" cellpadding="1" cellspacing="0" border="1"><tr>/i';
		$replace = '<table class="edit" style="width: 100%;" cellpadding="1" cellspacing="0" border="1"><tr style="display: none;">';
		$o = preg_replace($regexp, $replace, $o);
    }

    // EDITOR CALL
    if($plugin_cf['MLDadmin']['use_tinymce_editor'] == "true") {
        $cf['editor']['external'] = "tinymce";
    } else {
        $cf['editor']['external'] = "fckeditor";
    }

    //plupload section
    //check for file manage call        
    if($MLDimages) {
        $edit = false;
        $f = 'MLDfilebrowser';
        MLDfilebrowser('images');
    } elseif($MLDdownloads) {
        $edit = false;
        $f = 'MLDfilebrowser';
        MLDfilebrowser('downloads');
    }


    //settings save - to prevent template switch
    if ($action == 'save' && $file == 'config') {
        //if ($form == 'array') {
            $text = "<?php\n";
            $text.= "/* utf8-marker = äöüß */\n";
            foreach($cf as $k1 => $v1) {
                if (is_array($v1)) {
                    foreach($v1 as $k2 => $v2) {
                        if (!is_array($v2)) {
                            initvar($k1.'_'.$k2);
                            $cf[$k1][$k2] = $GLOBALS[$k1.'_'.$k2];
                            $cf[$k1][$k2] = stsl($cf[$k1][$k2]);
                        if ($k1.$k2 == 'editorbuttons')$text .= '$'.'cf'.'[\''.$k1.'\'][\''.$k2.'\']=\''.$cf[$k1][$k2].'\';';
                        else $text .= '$'.'cf'.'[\''.$k1.'\'][\''.$k2.'\']="'.preg_replace("/\"/s", "", $cf[$k1][$k2]).'";'."\n";
                        }
                    }
                }
            }
            $text .= '?>';
        //}
        //else $text = rmnl(stsl($text));
        if ($fh = @fopen($pth['file'][$file], "w")) {
            fwrite($fh, $text);
            fclose($fh);
            if (!@include($pth['file'][$file]))e('cntopen', $file, $pth['file'][$file]);
            if (!(preg_match('/\/[A-z]{2}\/[^\/]*/', sv('PHP_SELF')))) {
                $sl = $cf['language']['default'];
                $pth['file']['language'] = $pth['folder']['language'].$sl.'.php';
                if(isset($pth['file']['langconfig'])) $pth['file']['langconfig'] = $pth['folder']['language'].$sl.'config.php';
                if (!@include($pth['file']['language']))die('Language file '.$pth['file']['language'].' missing');
                if(isset($pth['file']['langconfig'])) if (!@include($pth['file']['langconfig']))die('Language config file '.$pth['file']['langconfig'].' missing');
            }
        } else e('cntwriteto', $file, $pth['file'][$file]);
        $action = '';
    }
}

/*
 * MLDADMIN FUNCTIONS
 */

/**
 *
 * function mldadminmenu returns separate adminmenu links for template
 *
 * @global mixed $sn
 * @global array $plugin_tx contains text strings from plugins
 * @global int $s selected number
 * @global boolean $mldeditorlogin logged in as editor yes/no
 * @param string $item which adminlink you want
 * @return string html link
 */
function MLDadminmenu($item) {
    global $sn, $plugin_tx, $s;
    
    if($item == 'settings') {           
        return '<a href="'.$sn.'?'.amp().'settings">'.$plugin_tx['MLDadmin']['editmenu_settings'].'</a>';
    } elseif ($item == 'logout') {
        return a($s, amp().'logout').$plugin_tx['MLDadmin']['editmenu_logout'].'</a>';
    } elseif ($item == 'cmsimple_xh') {
        return CMSIMPLE_XH_VERSION.'&nbsp;&nbsp;Build: '.CMSIMPLE_XH_BUILD.'&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<a href="http://www.cmsimple-xh.com/" target="_blank"><b>INFO &raquo;</b></a>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<a href="http://www.cmsimple-xh.de/faq/en/" target="_blank"><b>FAQ &raquo;</b></a>';
    }
}

/**
 *
 * function MLDeditmenu is replacement for original editmenu() function
 *
 * @global array $plugin_tx
 * @global mixed $sn
 * @global int $s
 * @global string $sl selected language
 * @global boolean $MLDeditorlogin
 * @global array $plugin_cf
 * @return string html menu
 */
function MLDeditmenu() {
    global $plugin_tx, $sn, $s, $sl, $plugin_cf, $edit, $preview;	
    $html = '<ul id="MLDem">';	
	if(!$edit && is_null($preview)) {
		$html.= '<li onmouseover="this.className=\'msieFix\'" onmouseout="this.className=\'\'">'.a(0, $h[0].amp().'edit').$plugin_tx['MLDadmin']['editmenu_edit'].'</a></li>';
	} else {
		$html.= '<li onmouseover="this.className=\'msieFix\'" onmouseout="this.className=\'\'">'.a($sn, amp().'normal'.amp().'preview').$plugin_tx['MLDadmin']['editmenu_preview'].'</a></li>';	
	}
    $html.= '<li onmouseover="this.className=\'msieFix\'" onmouseout="this.className=\'\'"><a href="'.$sn.'?'.amp().'validate">'.$plugin_tx['MLDadmin']['editmenu_validate'].'</a></li>';
    $html.= '<li onmouseover="this.className=\'msieFix\'" onmouseout="this.className=\'\'"><span class="editmenu_li">'.$plugin_tx['MLDadmin']['editmenu_files'].'</span>';
    $html.= '<ul>';
    $html.= '<li><a href="'.$sn.'?'.amp().'MLDimages">'.$plugin_tx['MLDadmin']['editmenu_images'].'</a></li>';
    $html.= '<li><a href="'.$sn.'?'.amp().'MLDdownloads">'.$plugin_tx['MLDadmin']['editmenu_downloads'].'</a></li>';
    $html.= '</ul></li>';
    $html.= '<li onmouseover="this.className=\'msieFix\'" onmouseout="this.className=\'\'"><a href="http://www.cmsimple.com/?User%27s_Manual'.amp().'language='.$sl.'" target="_blank">'.$plugin_tx['MLDadmin']['editmenu_help'].'</a></li>';
    if($plugin_cf['MLDadmin']['new_plugin_menu'] == 'true') {
        $html.= MLDpluginmenu();
    }
    $html.= '</ul>';
    return $html;
}

/**
 *
 * function MLDpluginmenu for creating new pluginmenu, modification of original function
 *
 * @global array $plugin_tx contains text strings from plugins
 * @global array $pth
 * @global mixed $sn
 * @return string pluginmenu
 */
function MLDpluginmenu() {
    global $plugin_tx, $pth, $sn;

    $i = 0;
    $pluginmenu = '<li onmouseover="this.className=\'msieFix\'" onmouseout="this.className=\'\'"><span>'.$plugin_tx['MLDadmin']['available_plugins'].'</span><ul>';
    $handle = opendir($pth['folder']['plugins']);
    $found_plugins = false;
    while (FALSE!==($plugin = readdir($handle))) {
        if($plugin != '.' && $plugin != '..' && is_dir($pth['folder']['plugins'].$plugin)) {
            PluginFiles($plugin);
            if(file_exists($pth['file']['plugin_admin'])) {
                $pluginmenu .= '<li><a href="'.$sn.'?&amp;'.$plugin.'&amp;normal">';

                $pluginmenu .= ucwords($plugin).'</a></li>';
                $found_plugins = true;
                $i++;
            }
        }
    }
    $pluginmenu .= '</ul></li>';
    if($found_plugins) {
        return $pluginmenu;
    } else {
        return '';
    }
}

/**
 *
 * function MLDfilebrowser as alternative for build-in filemanager
 *
 * @global array $plugin_tx
 * @global array $pth
 * @global string $title
 * @global string $o
 * @global array $cl
 * @global array $c
 * @global array $tx
 * @global array $h
 * @global array $cf
 * @global string $e
 * @global mixed $sn
 * @param string $type
 */
function MLDfilebrowser($type) {
    global $plugin_tx, $pth, $title, $o, $cl, $c, $tx, $h, $cf, $e, $sn;
    $title = $tx['title'][$type];
    $o = "\n\n".'<h1>'.$title.'</h1>'."\n";

    $regex = ($type == 'images') ? "/\.gif$|\.jpg$|\.jpeg$|\.png$/i" : "/^[^\.]/i";
    $action = (isset($_GET['action']) && ($_GET['action'] == 'mlddelete' || $_GET['action'] == 'mldupload')) ? $_GET['action'] : '';

    if ($action == 'mlddelete') {
        $file = $_GET['file'];
        if (!(preg_match($regex, $file))) {
            e('wrongext', 'file', $file);
        } else {
            if (@unlink($pth['folder'][$type].$file)) {
                $o .= '<p class="mld_succes">'.ucfirst($tx['filetype']['file']).' '.$file.' '.$tx['result']['deleted'].'</p>'."\n";
            } else e('cntdelete', 'file', $file);
        }
    }
    if ($action == 'mldupload') {
        $name = mldIm($type, 'name');       
        $size = mldIm($type, 'size');
        if (!(preg_match($regex, $name))) {
            e('wrongext', 'file', $name);
        } elseif (file_exists(rp($pth['folder'][$type].$name))) {
            e('alreadyexists', 'file', $name);
        } elseif ($size > $cf[$type]['maxsize']) {
            $e .= '<li>'.ucfirst($tx['filetype']['file']).' '.$name.' '.$tx['error']['tolarge'].' '.$cf[$type]['maxsize'].' '.$tx['files']['bytes'].'</li>'."\n";
        }
        if (!$e) {
            if (@move_uploaded_file(mldIm($type, 'tmp_name'), $pth['folder'][$type].$name)) {
                chmod($pth['folder'][$type].$name, 0644);
                $o .= '<p class="mld_succes">'.ucfirst($tx['filetype']['file']).' '.$name.' '.$tx['result']['uploaded'].'</p>'."\n";
            } else e('cntsave', 'file', $name);
        }
    }
    if ($cf[$type]['maxsize'] > 0) {
        $o .= '<form id="mld_uploadform" method="POST" action="'.$sn.'?'.amp().'MLD'.$type.amp().'action=mldupload" enctype="multipart/form-data">'."\n";
        $o.= '<p>'.tag('input type="file" class="file" name="'.$type.'" size="30"')."\n";
        $o.= tag('input type="submit" class="submit" value="'.ucfirst($tx['action']['upload']).'"')."\n".'</p>'."\n".'</form>'."\n";
    }

    $o.= '<div id="mld_filelist"><table id="mld_filelist_table" cellpadding="5" cellspacing="0">';

    $fs = sortdir($pth['folder'][$type]);
    $totalsize = 0;
    foreach ($fs as $p) {
        if (preg_match($regex, $p)) {
            $totalsize += filesize($pth['folder'][$type] . $p);
            $o.= ($type == 'images') ? '<tr><td>'.tag('img src="'.$pth['folder'][$type].$p.'" alt=""').'</td>' : '';
            $o.= '<td>'.$p.'</td>';
            $o.= '<td>'.round((filesize($pth['folder'][$type] . $p)) / 102.4) / 10 . ' KB</td>';
            if($type == 'images') {
                for ($i = 0; $i < $cl; $i++) {
                    $ic = preg_match_all('/<img src=["]*([^"]*?)' . '\/' . $p . '["]*(.*?)>/i', $c[$i], $matches, PREG_PATTERN_ORDER);
                    if ($ic > 0) {
                        $o .= tag('br') . $tx[$type]['usedin'] . ' ' . a($i, '') . $h[$i] . '</a>';
                    }
                }
            }            
            $o.= '<td><a href="'.$sn.'?'.amp().'MLD'.$type.amp().'action=mlddelete'.amp().'file='.$p.'">'.$tx['action']['delete'].'</a></td></tr>';
        }
    }

    $o.= '</table></div>';
    $action = '';
}

function mldIm($n, $p) {
	if (!isset($_FILES)) {
		global $_FILES;
		$_FILES = $GLOBALS['HTTP_POST_FILES'];
	}
	if (isset($_FILES[$n][$p]))return $_FILES[$n][$p];
	else return'';
}
?>